import stats
import lsa_model, pickle

# Sample strings from Landauer paper
# (http://lsa.colorado.edu/papers/dp1.LSAintro.pdf)
strings = [
	"Human machine interface for ABC computer applications",
	"A survey of user opinion of computer system response time",
	"The EPS user interface management system",
	"System and human system engineering testing of EPS",
	"Relation of user perceived response time to error measurement",
	"The generation of random, binary, ordered trees",
	"The intersection graph of paths in trees",
	"Graph minors IV: Widths of trees and well-quasi-ordering",
	"Graph minors: A survey"
]

files = [
	"test_data/doc1.txt", 
	"test_data/doc2.txt", 
	"test_data/doc3.txt"
]

Doyle = [
	"test_data/lostw10.txt", 
	"test_data/baskervilles.txt", 
	"test_data/parasite.txt", 
	"test_data/stark.txt"
]

initial_matrix=open("initial_matrix.dmp", 'w')
postweight_matrix=open("postweight_matrix.dmp", 'w')
postdimreduce_matrix=open("postdimreduce_matrix.dmp", 'w')


bob = lsa_model.lsa_model()

#bob.load_files(Doyle)
bob.load_strings(strings)
print
print "Initial frequencies"
bob.pretty_print()
#pickle.dump(bob.matrix,initial_matrix)


bob.strip_orphans()
print
print "After stripping orphans"
bob.pretty_print()


docs =  bob.compare_documents(stats.lspearmanr)
words = bob.compare_words(stats.lspearmanr)
lsa_model.export_to_csv(docs,"orig_docs.csv")
lsa_model.export_to_csv(words,"Orig_words.csv")

bob.apply_weights()
print
print "After weighting Functions"
bob.pretty_print()
#pickle.dump(bob.matrix,postweight_matrix)


bob.reduce_dimensions(2)
print
print "After reducing dimensions"
bob.pretty_print()
#pickle.dump(bob.matrix,postdimreduce_matrix)


docs =  bob.compare_documents(stats.lspearmanr)
words = bob.compare_words(stats.lspearmanr)
lsa_model.export_to_csv(docs,"docs.csv")
lsa_model.export_to_csv(words,"words.csv")



initial_matrix.close()
postweight_matrix.close()
postdimreduce_matrix.close()



"""
# playing with spearman rho values
print stats.lspearmanr(
	[0.26,0.84,0.61,0.70,0.39, 0.03, 0.08, 0.12, 0.19],
	[0.16,0.40,0.38,0.47,0.18,-0.05,-0.12,-0.16,-0.09])
print stats.lspearmanr(
	[1,0,0,1,0,0,0,0,0],
	[0,1,1,0,1,0,0,0,0])
print stats.lspearmanr([1,2,3,4,5],[2,3,4,5,6])
print stats.lspearmanr([1,2,3,4,5],[-2,-4,-6,-8,-10])
"""
