import stats
import lsa_model, pickle, time

# matlab: image(docs,'CDataMapping','scaled')

start_time = time.time()

files = []
# add hugo
for i in range(10):
	files.append("test_data/LesMisChunks/LesMiserables_"+repr(1050+i)+".txt")
# add doyle
for i in range(10):
	files.append("test_data/BaskervilleChunks/baskervilles_"+repr(1050+i)+".txt")


initial_matrix=open("initial_matrix.dmp", 'w')
postweight_matrix=open("postweight_matrix.dmp", 'w')
postdimreduce_matrix=open("postdimreduce_matrix.dmp", 'w')


hugo_vs_doyle = lsa_model.lsa_model()

hugo_vs_doyle.load_files(files)
print
print "Initial frequencies"
#hugo_vs_doyle.pretty_print()
pickle.dump(hugo_vs_doyle.matrix,initial_matrix)

hugo_vs_doyle.strip_orphans()
print
print "After stripping orphans"
#hugo_vs_doyle.pretty_print()

docs =  hugo_vs_doyle.compare_documents(stats.lspearmanr)
words = hugo_vs_doyle.compare_words(stats.lspearmanr)
lsa_model.export_to_csv(docs,"orig_docs.csv")
lsa_model.export_to_csv(words,"Orig_words.csv")

hugo_vs_doyle.apply_weights()
print
print "After weighting Functions"
#hugo_vs_doyle.pretty_print()
pickle.dump(hugo_vs_doyle.matrix,postweight_matrix)

hugo_vs_doyle.reduce_dimensions(2)
print
print "After reducing dimensions"
#hugo_vs_doyle.pretty_print()
pickle.dump(hugo_vs_doyle.matrix,postdimreduce_matrix)

docs =  hugo_vs_doyle.compare_documents(stats.lspearmanr)
#words = hugo_vs_doyle.compare_words(stats.lspearmanr)
lsa_model.export_to_csv(docs,"docs.csv")
#lsa_model.export_to_csv(words,"words.csv")

initial_matrix.close()
postweight_matrix.close()
postdimreduce_matrix.close()

end_time = time.time()

print repr(hugo_vs_doyle.matrix.getshape()) + " matrix created."
print repr(end_time - start_time) + " seconds elapsed."
